import es

class IVS(object):
    class Player(object):
        def __init__(self, userid):
            self.userid   = userid
            self.attacked = []
        
        def removeAttacked(self):
            del self.attacked[:]
        
        def playerHurt(self, userid):
            if userid != self.userid:
                self.attacked.append(userid)
        
        def playerDeath(self, attacker):
            if attacker != self.userid:
                text = ['#green[#lightgreenBIVS#green] #defaultKiller: #green%s' % es.getplayername(attacker)]
                if attacker in self.attacked:
                    text.append('#defaultwith #lightgreen%s #defaultHP left.' % es.getplayerprop(attacker, 'CBasePlayer.m_iHealth'))
                es.tell(self.userid, '#multi', ' '.join(text))
                self.removeAttacked()
    
    def __init__(self):
        self.players = {}
    
    def insertUserid(self, userid):
        userid = str(userid)
        self.players[userid] = self.Player(userid)
    
    def removeUserid(self, userid=0, unload=False):
        if not unload and userid in self.players:
            del self.players[userid]
        elif unload:
            self.players.clear()
    
    def roundStart(self):
        for userid in self.players.copy():
            self.players[userid].removeAttacked()
    
    def playerHurt(self, userid, attacker):
        self.players[attacker].playerHurt(userid)
    
    def playerDeath(self, userid, attacker):
        self.players[userid].playerDeath(attacker)
    
    def scriptLoad(self):
        for userid in es.getUseridList():
            self.insertUserid(userid)
        es.ServerVar('bivs_ver', 1.0, "BackRaw's Intelligent Victim Stats").makepublic()
    
    def scriptUnload(self):
        self.removeUserid(unload=True)

ivs = IVS()

def round_start(ev):
    ivs.roundStart()

def player_activate(ev):
    ivs.insertUserid(ev['userid'])

def player_hurt(ev):
    ivs.playerHurt(ev['userid'], ev['attacker'])

def player_death(ev):
    ivs.playerDeath(ev['userid'], ev['attacker'])

def player_disconnect(ev):
    ivs.removeUserid(ev['userid'])

def load():
    ivs.scriptLoad()

def unload():
    ivs.scriptUnload()
